\documentclass[10pt]{article}

\usepackage[margin=0.5in,bottom=.7in,top=.8in]{geometry}
\usepackage{graphicx}\graphicspath{{figures/}}
\usepackage[usenames,dvipsnames]{xcolor}
\usepackage[colorlinks=true,citecolor=Mahogany,linkcolor=Mahogany,urlcolor=Mahogany,filecolor=Mahogany]{hyperref}
\usepackage{breakurl}
\usepackage{url}
\usepackage[nocompress]{cite}
\usepackage{paralist}
\usepackage{authblk}
\usepackage{enumitem}
\usepackage{multirow}

\title{NFD Developer's Guide}
\author[1]{Alexander Afanasyev}
\author[2]{Junxiao Shi}
\author[2]{Beichuan Zhang}
\author[1]{Lixia Zhang}
\author[1]{Ilya Moiseenko}
\author[1]{Yingdi Yu}
\author[1]{Wentao Shang}
\author[1]{Yanbiao Li}
\author[1]{Spyridon Mastorakis}
\author[2]{Yi Huang}
\author[2]{Jerald Paul Abraham}
\author[2]{Eric Newberry}
\author[3]{Steve DiBenedetto}
\author[3]{Chengyu Fan}
\author[3]{Christos Papadopoulos}
\author[4]{Davide Pesavento}
\author[4]{Giulio Grassi}
\author[4]{Giovanni Pau}
\author[5]{Hang Zhang}
\author[5]{Tian Song}
\author[6]{Haowei Yuan}
\author[6]{Hila Ben Abraham}
\author[6]{Patrick Crowley}
\author[7]{Syed Obaid Amin}
\author[7]{Vince Lehman}
\author[7]{Muktadir Chowdhury}
\author[7]{Lan Wang}
\author[7]{Ashlesh Gawande}

\affil[1]{University of California, Los Angeles}
\affil[2]{The University of Arizona}
\affil[3]{Colorado State University}
\affil[4]{University Pierre \& Marie Curie, Sorbonne University}
\affil[5]{Beijing Institute of Technology}
\affil[6]{Washington University in St. Louis}
\affil[7]{The University of Memphis}

\date{NFD Team}

\usepackage{fancyhdr}
\pagestyle{fancy}


\usepackage{eso-pic,xcolor}
\makeatletter
\AddToShipoutPicture*{%
\setlength{\@tempdimb}{20pt}%
\setlength{\@tempdimc}{\paperheight}%
\setlength{\unitlength}{1pt}%
\put(\strip@pt\@tempdimb,\strip@pt\@tempdimc){%
    \makebox(0,-60)[l]{\color{blue}%
NDN, Technical Report NDN-0021. \url{http://named-data.net/techreports.html}}
  }%
}
\makeatother


\begin{document}
\maketitle

\begin{abstract}
NDN Forwarding Daemon (NFD) is a network forwarder that implements the Named Data Networking (NDN) protocol. NFD is designed with \emph{modularity} and \emph{extensibility} in mind to enable easy experiments with new protocol features, algorithms, and applications for NDN. To help developers extend and improve NFD, this document explains NFD's internals including the overall design, major modules, their implementations, and their interactions.

\end{abstract}

\section*{Revision history}

\begin{itemize}
\item \textbf{Revision 8 (TBD, 2017)}:
  \begin{itemize}[nosep,after=\strut]
  \item Description of new semantics of NextHopFaceId
  \item Command Authenticator
  \item Correct content store policy description
  \item Unsolicited data policy
  \item TCP permanent face
  \item Forwarding pipeline updates, including semantics of removing Link object from interest when it reaches producer region
  \item Scope control in strategies
  \item Strategy parameters
  \item Content Store policy configuration and policy API
  \item Multicast whitelist and blacklist
  \item Updated description of face system
  \item \texttt{nicfaces} configuration
  \end{itemize}


\item \textbf{Revision 7 (October 4, 2016)}:
  \begin{itemize}[nosep,after=\strut]
  \item Added brief description and reference to the new Adaptive SRTT-based (ASF) forwarding strategy
  \item Update description of Strategy API to reflect latest changes
  \item Miscellaneous updates
  \end{itemize}

\item \textbf{Revision 6 (March 25, 2016)}:
  \begin{itemize}[nosep,after=\strut]
  \item Added description of refactored Face system (Face, LinkService, Transport)
  \item Added description of WebSocket transport
  \item Updated description of RIB management
  \item Added description of Nack processing
  \item Added introductory description of NDNLP
  \item Added description of best-route retransmission suppression
  \item Other updates to synchronize description with current NFD implementation
  \end{itemize}

\item \textbf{Revision 5 (Oct 27, 2015)}:
  \begin{itemize}[nosep,after=\strut]
  \item Add description of CS CachePolicy API, including information about new LRU policy
  \item BroadcastStrategy renamed to MulticastStrategy
  \item Added overview of how forwarder processes Link objects
  \item Added overview of the new face system (incomplete)
  \item Added description of the new automatic prefix propagation feature
  \item Added description of the refactored management
  \item Added description of NetworkRegionTable configuration
  \item Added description about client.conf and NFD
  \end{itemize}

\item \textbf{Revision 4 (May 12, 2015)}:
  New section about testing and updates for NFD version 0.3.2:
  \begin{itemize}[nosep,after=\strut]
  \item Added description of new ContentStore implementation, including a new async lookup model of CS
  \item Added description of the remote prefix registration
  \item Updated Common Services section
  \end{itemize}

\item \textbf{Revision 3 (February 3, 2015)}:
  Updates for NFD version 0.3.0:
  \begin{itemize}[nosep,after=\strut]
  \item In Strategy interface, beforeSatisfyPendingInterest renamed to beforeSatisfyInterest
  \item Added description of dead nonce list and related changes to forwarding pipelines
  \item Added description of a new \verb|strategy_choice| config file subsection
  \item Amended unix config text to reflect removal of "listen" option
  \item Added discussion about encapsulationg of NDN packets inside WebSocket messages
  \item Revised FaceManager description, requiring canonical FaceUri in create operations
  \item Added description of the new access router strategy
  \end{itemize}

\item \textbf{Revision 2 (August 25, 2014)}:
  Updated steps in forwarding pipelines, \texttt{nfd::BestRouteStrategy} is replaced with \texttt{nfd::BestRouteStrategy2} that allows client-based recovery from Interest losses

\item \textbf{Revision 1 (July 1, 2014)}:
  Initial release
\end{itemize}


\clearpage
\tableofcontents
\clearpage


\input{intro}\clearpage
\input{face}\clearpage
\input{tab}\clearpage
\input{fw}\clearpage
\input{strategy}\clearpage
\input{mgmt}\clearpage
\input{rib}\clearpage
\input{security}\clearpage
\input{core}\clearpage
\input{testing}\clearpage

\phantomsection
\addcontentsline{toc}{section}{References}

\bibliographystyle{IEEEtran}
\bibliography{ref,rfc}

\end{document}
